#pragma once


namespace r07_semafory {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary>
	/// Summary for Form1
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public ref class OknoGlowne : public System::Windows::Forms::Form
	{
	private:
		// Rozmiar bufora 
		initonly int rozmiar;
		// Kolekcja penica funkcj bufora danych
		System::Collections::ObjectModel::Collection<int>^ bufor;
		// Semafory
		// - semafor binarny synchronizujcy operacje zapisu i odczytu
		System::Threading::Semaphore^ sekcjaKrytyczna;
		// - semafor umoliwiajcy producentowi wyprodukowanie elementu
		System::Threading::Semaphore^ buforPusty;
		// - semafor umoliwiajcy konsumentowi odczyt elementu
		System::Threading::Semaphore^ buforPelny;

		// Generator liczb pseudolosowych
		Random^ rnd;

		// Wtki
		System::ComponentModel::BackgroundWorker^  producent;
		System::ComponentModel::BackgroundWorker^  konsument1;
		System::ComponentModel::BackgroundWorker^  konsument2;

		// Interfejs uytkownika
		System::Windows::Forms::Label^  label1;
		System::Windows::Forms::Label^  label2;
		System::Windows::Forms::ListBox^  lbKonsument2;
	private: System::Windows::Forms::GroupBox^  groupBox1;
	private: System::Windows::Forms::TextBox^  txtOdczyt1;

	private: System::Windows::Forms::TextBox^  txtProd;
	private: System::Windows::Forms::Label^  label6;
	private: System::Windows::Forms::Label^  label5;
	private: System::Windows::Forms::Label^  label4;
	private: System::Windows::Forms::TextBox^  txtOdczyt2;

			 System::Windows::Forms::Label^  label3;


	public:
		OknoGlowne(void)
		{
			InitializeComponent();
			//
			//TODO: Add the constructor code here
			//

			// Przygotowanie bufora
			rozmiar = 3;
			bufor = gcnew System::Collections::ObjectModel::Collection<int>();
			// Inicjalizacja semaforw
			sekcjaKrytyczna = gcnew System::Threading::Semaphore(1, 1);
			buforPelny = gcnew System::Threading::Semaphore(0, rozmiar);
			buforPusty = gcnew System::Threading::Semaphore(rozmiar, rozmiar);
			// Generator liczb pseudolosowych
			rnd = gcnew Random();
			// Uruchamiam wtki
			konsument1->RunWorkerAsync();
			konsument2->RunWorkerAsync();
			producent->RunWorkerAsync();
		}

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~OknoGlowne()
		{
			if (components)
			{
				delete components;
			}
		}

	protected: 


	private: System::Windows::Forms::ListBox^  lbProducent;
	private: System::Windows::Forms::ListBox^  lbKonsument1;

	protected: 




	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->lbProducent = (gcnew System::Windows::Forms::ListBox());
			this->lbKonsument1 = (gcnew System::Windows::Forms::ListBox());
			this->producent = (gcnew System::ComponentModel::BackgroundWorker());
			this->konsument1 = (gcnew System::ComponentModel::BackgroundWorker());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->lbKonsument2 = (gcnew System::Windows::Forms::ListBox());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->konsument2 = (gcnew System::ComponentModel::BackgroundWorker());
			this->groupBox1 = (gcnew System::Windows::Forms::GroupBox());
			this->txtOdczyt2 = (gcnew System::Windows::Forms::TextBox());
			this->txtOdczyt1 = (gcnew System::Windows::Forms::TextBox());
			this->txtProd = (gcnew System::Windows::Forms::TextBox());
			this->label6 = (gcnew System::Windows::Forms::Label());
			this->label5 = (gcnew System::Windows::Forms::Label());
			this->label4 = (gcnew System::Windows::Forms::Label());
			this->groupBox1->SuspendLayout();
			this->SuspendLayout();
			// 
			// lbProducent
			// 
			this->lbProducent->FormattingEnabled = true;
			this->lbProducent->Location = System::Drawing::Point(12, 23);
			this->lbProducent->Name = L"lbProducent";
			this->lbProducent->Size = System::Drawing::Size(235, 186);
			this->lbProducent->TabIndex = 2;
			// 
			// lbKonsument1
			// 
			this->lbKonsument1->FormattingEnabled = true;
			this->lbKonsument1->Location = System::Drawing::Point(12, 228);
			this->lbKonsument1->Name = L"lbKonsument1";
			this->lbKonsument1->Size = System::Drawing::Size(235, 186);
			this->lbKonsument1->TabIndex = 3;
			// 
			// producent
			// 
			this->producent->WorkerReportsProgress = true;
			this->producent->DoWork += gcnew System::ComponentModel::DoWorkEventHandler(this, &OknoGlowne::producent_DoWork);
			this->producent->ProgressChanged += gcnew System::ComponentModel::ProgressChangedEventHandler(this, &OknoGlowne::producent_ProgressChanged);
			// 
			// konsument1
			// 
			this->konsument1->WorkerReportsProgress = true;
			this->konsument1->DoWork += gcnew System::ComponentModel::DoWorkEventHandler(this, &OknoGlowne::konsument1_DoWork);
			this->konsument1->ProgressChanged += gcnew System::ComponentModel::ProgressChangedEventHandler(this, &OknoGlowne::konsument1_ProgressChanged);
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Location = System::Drawing::Point(12, 7);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(59, 13);
			this->label1->TabIndex = 4;
			this->label1->Text = L"Producent:";
			// 
			// label2
			// 
			this->label2->AutoSize = true;
			this->label2->Location = System::Drawing::Point(12, 212);
			this->label2->Name = L"label2";
			this->label2->Size = System::Drawing::Size(72, 13);
			this->label2->TabIndex = 5;
			this->label2->Text = L"Konsument 1:";
			// 
			// lbKonsument2
			// 
			this->lbKonsument2->FormattingEnabled = true;
			this->lbKonsument2->Location = System::Drawing::Point(262, 228);
			this->lbKonsument2->Name = L"lbKonsument2";
			this->lbKonsument2->Size = System::Drawing::Size(225, 186);
			this->lbKonsument2->TabIndex = 6;
			// 
			// label3
			// 
			this->label3->AutoSize = true;
			this->label3->Location = System::Drawing::Point(259, 212);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(72, 13);
			this->label3->TabIndex = 7;
			this->label3->Text = L"Konsument 2:";
			// 
			// konsument2
			// 
			this->konsument2->WorkerReportsProgress = true;
			this->konsument2->DoWork += gcnew System::ComponentModel::DoWorkEventHandler(this, &OknoGlowne::konsument2_DoWork);
			this->konsument2->ProgressChanged += gcnew System::ComponentModel::ProgressChangedEventHandler(this, &OknoGlowne::konsument2_ProgressChanged);
			// 
			// groupBox1
			// 
			this->groupBox1->Controls->Add(this->txtOdczyt2);
			this->groupBox1->Controls->Add(this->txtOdczyt1);
			this->groupBox1->Controls->Add(this->txtProd);
			this->groupBox1->Controls->Add(this->label6);
			this->groupBox1->Controls->Add(this->label5);
			this->groupBox1->Controls->Add(this->label4);
			this->groupBox1->Location = System::Drawing::Point(262, 12);
			this->groupBox1->Name = L"groupBox1";
			this->groupBox1->Size = System::Drawing::Size(225, 197);
			this->groupBox1->TabIndex = 8;
			this->groupBox1->TabStop = false;
			this->groupBox1->Text = L"Statystyki";
			// 
			// txtOdczyt2
			// 
			this->txtOdczyt2->Location = System::Drawing::Point(9, 112);
			this->txtOdczyt2->Name = L"txtOdczyt2";
			this->txtOdczyt2->ReadOnly = true;
			this->txtOdczyt2->Size = System::Drawing::Size(100, 20);
			this->txtOdczyt2->TabIndex = 5;
			// 
			// txtOdczyt1
			// 
			this->txtOdczyt1->Location = System::Drawing::Point(9, 73);
			this->txtOdczyt1->Name = L"txtOdczyt1";
			this->txtOdczyt1->ReadOnly = true;
			this->txtOdczyt1->Size = System::Drawing::Size(100, 20);
			this->txtOdczyt1->TabIndex = 4;
			// 
			// txtProd
			// 
			this->txtProd->Location = System::Drawing::Point(9, 33);
			this->txtProd->Name = L"txtProd";
			this->txtProd->ReadOnly = true;
			this->txtProd->Size = System::Drawing::Size(100, 20);
			this->txtProd->TabIndex = 3;
			// 
			// label6
			// 
			this->label6->AutoSize = true;
			this->label6->Location = System::Drawing::Point(6, 96);
			this->label6->Name = L"label6";
			this->label6->Size = System::Drawing::Size(210, 13);
			this->label6->TabIndex = 2;
			this->label6->Text = L"Ilo elementw pobranych - Konsument 2:";
			// 
			// label5
			// 
			this->label5->AutoSize = true;
			this->label5->Location = System::Drawing::Point(6, 56);
			this->label5->Name = L"label5";
			this->label5->Size = System::Drawing::Size(210, 13);
			this->label5->TabIndex = 1;
			this->label5->Text = L"Ilo elementw pobranych - Konsument 1:";
			// 
			// label4
			// 
			this->label4->AutoSize = true;
			this->label4->Location = System::Drawing::Point(6, 16);
			this->label4->Name = L"label4";
			this->label4->Size = System::Drawing::Size(178, 13);
			this->label4->TabIndex = 0;
			this->label4->Text = L"Ilo wyprodukowanych elementw:";
			// 
			// OknoGlowne
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(499, 424);
			this->Controls->Add(this->groupBox1);
			this->Controls->Add(this->label3);
			this->Controls->Add(this->lbKonsument2);
			this->Controls->Add(this->label2);
			this->Controls->Add(this->label1);
			this->Controls->Add(this->lbKonsument1);
			this->Controls->Add(this->lbProducent);
			this->Name = L"OknoGlowne";
			this->Text = L"Semafory";
			this->groupBox1->ResumeLayout(false);
			this->groupBox1->PerformLayout();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion
private: System::Void producent_DoWork(System::Object^  sender, System::ComponentModel::DoWorkEventArgs^  e) {
			 BackgroundWorker^ worker = dynamic_cast<BackgroundWorker^>(sender);
			 int i = 0;
			 while (true) {
				// Sekcja krytyczna
				buforPusty->WaitOne();
				sekcjaKrytyczna->WaitOne();

				bufor->Add(i);			
				worker->ReportProgress(0, String::Format("Dodaem element o wartoci {0}.", i));
				i++;

				sekcjaKrytyczna->Release();
				buforPelny->Release();
				// pimy
				System::Threading::Thread::Sleep(300);
			 }
		 }

private: System::Void konsument1_DoWork(System::Object^  sender, System::ComponentModel::DoWorkEventArgs^  e) {
			 BackgroundWorker^ worker = dynamic_cast<BackgroundWorker^>(sender);
			 int odczyt = 0;
			 while (true) {
				// Sekcja krytyczna
				buforPelny->WaitOne();
				sekcjaKrytyczna->WaitOne();

				odczyt = bufor[0];			
				bufor->RemoveAt(0);

				worker->ReportProgress(0, String::Format("Odczytaem element o wartoci {0}.", odczyt));

				sekcjaKrytyczna->Release();
				buforPusty->Release();
				// pimy
				System::Threading::Thread::Sleep(300);
			 }
		 }

private: System::Void konsument2_DoWork(System::Object^  sender, System::ComponentModel::DoWorkEventArgs^  e) {
			 BackgroundWorker^ worker = dynamic_cast<BackgroundWorker^>(sender);
			 int odczyt = 0;
			 while (true) {
				// Sekcja krytyczna
				buforPelny->WaitOne();
				sekcjaKrytyczna->WaitOne();

				odczyt = bufor[0];			
				bufor->RemoveAt(0);
				
				worker->ReportProgress(0, String::Format("Odczytaem element o wartoci {0}.", odczyt));

				sekcjaKrytyczna->Release();
				buforPusty->Release();
				// pimy
				System::Threading::Thread::Sleep(1000);
			 }
		 }

private: System::Void producent_ProgressChanged(System::Object^  sender, System::ComponentModel::ProgressChangedEventArgs^  e) {
			 static int i;
			 txtProd->Text = System::Convert::ToString(i + 1);
			 i++;

			 lbProducent->Items->Add(e->UserState);
			 lbProducent->SelectedIndex = lbProducent->Items->Count - 1;
		 }
private: System::Void konsument1_ProgressChanged(System::Object^  sender, System::ComponentModel::ProgressChangedEventArgs^  e) {
			 static int i;
			 txtOdczyt1->Text = System::Convert::ToString(i + 1);
			 i++;

			 lbKonsument1->Items->Add(e->UserState);
			 lbKonsument1->SelectedIndex = lbKonsument1->Items->Count - 1;
		 }
private: System::Void konsument2_ProgressChanged(System::Object^  sender, System::ComponentModel::ProgressChangedEventArgs^  e) {
			 static int i;
			 txtOdczyt2->Text = System::Convert::ToString(i + 1);
			 i++;

			 lbKonsument2->Items->Add(e->UserState);
			 lbKonsument2->SelectedIndex = lbKonsument2->Items->Count - 1;
		 }
};
}

